""" 
 * (C) COPYRIGHT International Business Machines Corp. 2012, 2013. All Rights Reserved
 * US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
"""

#######################################################
# wsadmin script to deploy Emptoris Contract Management
#######################################################

########### Start Imports ###########
from install.GetProfilePath import GetProfilePath
from install.WASService import WASService

from util.Boolean import * 
import util.utility as util

import was_objs.import_was as wasScript
execfile(wasScript.__file__)
########### End Imports ###########

########### Start Variable Definitions ###########
wasHome = args['wasHome']
profileName = args['profileName']
serverName = args['serverName']
nodeName = args['nodeName']
cellName = args['cellName']
contextRoot = args['contextRoot']
appName = args['appName']

########### End Variable Definitions ###########

# Make sure the WAS profile exists
profilePath = GetProfilePath(wasHome).getProfilePath(profileName)
if profilePath is None:
	raise Exception('Could not find target profile path for profile [' + profileName + ']') 

try:
	print "Deploy Cognos BI Integration Cognos Gateway Server ..."

	########### Create a new server ###########
	svr = server.Server(serverName, nodeName, cellName)
        svr.setPortSet(args['portSet'])
        svr.configure()
	
	########### Transaction Time out 
	serverConfigId = svr.getConfigId()

	########### Start Application Deployment ###########
	print "Application Deployment Started ..."
	inst = installer.Installer(args['appWarLocation'], args['installerPropertiesLocation'])
	inst.setServer(svr)
		
	inst.setCtxRootForWebMod([["IBM Cognos Servlet Gateway", 'ServletGateway.war,WEB-INF/web.xml', contextRoot]])   
	inst.setProcessEmbeddedConfig(false)
	inst.setNoprocessEmbeddedConfig(true)
	inst.configure()
	
	# Usergroup mapping
	AdminApp.edit(appName, '[ -MapRolesToUsers [[ authenticated-users AppDeploymentOption.No AppDeploymentOption.No "" "" AppDeploymentOption.Yes "" "" ]]]' ) 
	
	print "Saving changes..."
	AdminConfig.save()
	print "Changes saved..."
	
	########### End Application Deployment ###########
except Exception, e:
	print "Server configuration failed.  Rolling back changes."
	AdminConfig.reset()
	raise # Re-throw to terminate the script
